using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Thirdparty.CustomerContact.Cqrs;

public record DeleteCustomerContactByIdRequest(string Id);

public record DeleteCustomerContactByIdCommand(DeleteCustomerContactByIdRequest Data) : IRequest<bool>;

public class DeleteCustomerContactByIdHandler : IRequestHandler<DeleteCustomerContactByIdCommand, bool>
{
    private readonly AppDbContext _context;

    public DeleteCustomerContactByIdHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeleteCustomerContactByIdCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.CustomerContact
            .FirstOrDefaultAsync(x => x.Id == request.Data.Id, cancellationToken);

        if (entity == null) return false;

        _context.CustomerContact.Remove(entity);
        return await _context.SaveChangesAsync(cancellationToken) > 0;
    }
}